require 'yaml'
require 'assent/exceptions/config_exception'

module Assent
  module Config

    def initialize
      if Config.config.empty?
        lang = YAML.load_file(File.dirname(__FILE__) + '/lang.yml')

        lang.each do |key, value|
          Config.add(key, value)
        end
      end
    end

    def self.config_file(path)
      begin
        lang = YAML.load_file(path)
        lang.each do |key, value|
          add(key, value)
        end
      rescue Errno::ENOENT
        raise ConfigException.new "Config file could not be found."
      end
    end

    def self.add(option, value)
      config[option] = value
    end

    def self.config
      @@config ||= Hash.new
    end

    private

    def set_empty_config
      @@config = Hash.new
    end

  end
end
