require 'assent/validations/field'
require 'assent/validations/options'
require 'assent/config/config'
require 'assent/validations/validator'
require 'assent/validations/errors'

module Assent
  class Validator
    include Field
    include Options
    include Config

    def errors_class
      @errors ||= Errors.new
    end

    def errors
      errors_class.errors
    end

    # This validate method will validate the input against the rules. At the end it returns true or false.
    # If the errors are empty, it means the validation passed
    def validate(input)
      @@validations.each do |field, validations|
        value = input[field]
        value = input[field].to_s if value.nil?
        validate = Validate.new(field, value, validations, errors_class)
        validate.validate
      end

      errors.empty?
    end

  end
end
